package ru.dbotthepony.kstarbound.world.api

import ru.dbotthepony.kvector.api.IStruct2i

// for getting tiles directly, avoiding manual layer specification
interface ITileChunk : IChunk {
	// relative
	fun getTile(x: Int, y: Int): ITileState
	fun getTile(pos: IStruct2i) = getTile(pos.component1(), pos.component2())
}

class ForegroundView(private val parent: IChunk) : ITileChunk, IChunk by parent {
	override fun getTile(x: Int, y: Int): ITileState {
		return parent.getCell(x, y).foreground
	}
}

class BackgroundView(private val parent: IChunk) : ITileChunk, IChunk by parent {
	override fun getTile(x: Int, y: Int): ITileState {
		return parent.getCell(x, y).background
	}
}